"use strict";
/*!
 * Paradigm UI Web
 * Copyright (c) 2017 Miracle Devs, Inc
 * Licensed under MIT (https://gitlab.com/miracledevs-paradigm/ui-web-angularjs/blob/master/LICENSE)
 */
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var base_directive_1 = require("./base.directive");
var directive_1 = require("../decorators/directive");
var angular_service_1 = require("../services/angular.service");
var FocusWhen = /** @class */ (function (_super) {
    tslib_1.__extends(FocusWhen, _super);
    function FocusWhen(timeout) {
        var _this = _super.call(this) || this;
        _this.timeout = timeout;
        _this.restrict = "A";
        return _this;
    }
    FocusWhen_1 = FocusWhen;
    FocusWhen.prototype.create = function (scope, instanceElement, instanceAttributes, controller, transclude) {
        var _this = this;
        var focusDelay = 100;
        if (instanceAttributes["focus-delay"])
            focusDelay = parseInt(instanceAttributes["focus-delay"]);
        scope.$watch(function () { return instanceAttributes["focusWhen"]; }, function () {
            _this.timeout(function () {
                try {
                    var model = scope.$eval(instanceAttributes["focusWhen"]);
                    if (model) {
                        instanceElement.focus();
                    }
                }
                catch (e) {
                }
            }, focusDelay);
        });
    };
    FocusWhen.factory = function (timeout) {
        return new FocusWhen_1(timeout);
    };
    FocusWhen = FocusWhen_1 = tslib_1.__decorate([
        directive_1.Directive({
            name: "focusWhen",
            factory: FocusWhen_1.factory,
            dependencies: [angular_service_1.AngularServices.timeout]
        })
    ], FocusWhen);
    return FocusWhen;
    var FocusWhen_1;
}(base_directive_1.DirectiveBase));
exports.FocusWhen = FocusWhen;
