"use strict";
/*!
 * Paradigm UI Web
 * Copyright (c) 2017 Miracle Devs, Inc
 * Licensed under MIT (https://gitlab.com/miracledevs-paradigm/ui-web-angularjs/blob/master/LICENSE)
 */
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var directive_1 = require("../decorators/directive");
var base_directive_1 = require("./base.directive");
var paradigm_ui_web_shared_1 = require("@miracledevs/paradigm-ui-web-shared");
var FormatAsNumber = /** @class */ (function (_super) {
    tslib_1.__extends(FormatAsNumber, _super);
    function FormatAsNumber() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.restrict = "A";
        _this.require = "?ngModel";
        return _this;
    }
    FormatAsNumber_1 = FormatAsNumber;
    FormatAsNumber.prototype.create = function (scope, instanceElement, instanceAttributes, controller, transclude) {
        if (!paradigm_ui_web_shared_1.ObjectExtensions.isNull(controller)) {
            controller.$formatters.unshift(function (value) {
                return (paradigm_ui_web_shared_1.ObjectExtensions.isNull(value) || value === "") ? null : new Number(value).toFixed(instanceAttributes["decimalPlaces"] || 2);
            });
            controller.$parsers.unshift(function (value) {
                return (paradigm_ui_web_shared_1.ObjectExtensions.isNull(value) || value === "") ? null : new Number(value).valueOf();
            });
            instanceElement.blur(function () {
                var value = instanceElement.val();
                return instanceElement.val((paradigm_ui_web_shared_1.ObjectExtensions.isNull(value) || value === "") ? null : new Number(instanceElement.val()).toFixed(instanceAttributes["decimalPlaces"] || 2));
            });
        }
    };
    FormatAsNumber.factory = function () {
        return new FormatAsNumber_1();
    };
    FormatAsNumber = FormatAsNumber_1 = tslib_1.__decorate([
        directive_1.Directive({
            name: "formatAsNumber",
            factory: FormatAsNumber_1.factory
        })
    ], FormatAsNumber);
    return FormatAsNumber;
    var FormatAsNumber_1;
}(base_directive_1.DirectiveBase));
exports.FormatAsNumber = FormatAsNumber;
