"use strict";
/*!
 * Paradigm UI Web
 * Copyright (c) 2017 Miracle Devs, Inc
 * Licensed under MIT (https://gitlab.com/miracledevs-paradigm/ui-web-angularjs/blob/master/LICENSE)
 */
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var directive_1 = require("../decorators/directive");
var framework_service_1 = require("../services/framework.service");
var base_directive_1 = require("./base.directive");
var OnKeyboard = /** @class */ (function (_super) {
    tslib_1.__extends(OnKeyboard, _super);
    function OnKeyboard(keyProcessor) {
        var _this = _super.call(this) || this;
        _this.keyProcessor = keyProcessor;
        _this.restrict = "A";
        return _this;
    }
    OnKeyboard_1 = OnKeyboard;
    OnKeyboard.prototype.create = function (scope, instanceElement, instanceAttributes, controller, transclude) {
        var _this = this;
        var keyActions = this.keyProcessor.parseActions(instanceAttributes["onKeyboard"]);
        if (keyActions.any(function (x) { return x.eventType === "keypress"; }))
            instanceElement.keypress(function (e) { return _this.keyProcessor.evaluateKeyActions(keyActions, "keypress", scope, e); });
        if (keyActions.any(function (x) { return x.eventType === "keydown"; }))
            instanceElement.keydown(function (e) { return _this.keyProcessor.evaluateKeyActions(keyActions, "keydown", scope, e); });
        if (keyActions.any(function (x) { return x.eventType === "keyup"; }))
            instanceElement.keyup(function (e) { return _this.keyProcessor.evaluateKeyActions(keyActions, "keyup", scope, e); });
    };
    OnKeyboard.factory = function (keyProcessor) {
        return new OnKeyboard_1(keyProcessor);
    };
    OnKeyboard = OnKeyboard_1 = tslib_1.__decorate([
        directive_1.Directive({
            name: "onKeyboard",
            factory: OnKeyboard_1.factory,
            dependencies: [framework_service_1.FrameworkServices.keyProcessorService]
        })
    ], OnKeyboard);
    return OnKeyboard;
    var OnKeyboard_1;
}(base_directive_1.DirectiveBase));
exports.OnKeyboard = OnKeyboard;
