"use strict";
/*!
 * Paradigm UI Web
 * Copyright (c) 2017 Miracle Devs, Inc
 * Licensed under MIT (https://gitlab.com/miracledevs-paradigm/ui-web-angularjs/blob/master/LICENSE)
 */
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var directive_1 = require("../decorators/directive");
var angular_service_1 = require("../services/angular.service");
var base_directive_1 = require("./base.directive");
var PreventEventIf = /** @class */ (function (_super) {
    tslib_1.__extends(PreventEventIf, _super);
    function PreventEventIf(timeout) {
        var _this = _super.call(this) || this;
        _this.timeout = timeout;
        _this.restrict = "A";
        _this.scope = {
            preventEventIf: "&",
            preventEvent: "@"
        };
        return _this;
    }
    PreventEventIf_1 = PreventEventIf;
    PreventEventIf.prototype.create = function (scope, instanceElement, instanceAttributes, controller, transclude) {
        instanceElement.on(scope["preventEvent"], function (e) {
            if (scope["preventEventIf"]()) {
                event.preventDefault();
                e.stopPropagation();
            }
        });
    };
    PreventEventIf.factory = function (timeout) {
        return new PreventEventIf_1(timeout);
    };
    PreventEventIf = PreventEventIf_1 = tslib_1.__decorate([
        directive_1.Directive({
            name: "preventEventIf",
            factory: PreventEventIf_1.factory,
            dependencies: [angular_service_1.AngularServices.timeout]
        })
    ], PreventEventIf);
    return PreventEventIf;
    var PreventEventIf_1;
}(base_directive_1.DirectiveBase));
exports.PreventEventIf = PreventEventIf;
