"use strict";
/*!
 * Paradigm UI Web
 * Copyright (c) 2017 Miracle Devs, Inc
 * Licensed under MIT (https://gitlab.com/miracledevs-paradigm/ui-web-angularjs/blob/master/LICENSE)
 */
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var directive_1 = require("../decorators/directive");
var angular_service_1 = require("../services/angular.service");
var base_directive_1 = require("./base.directive");
var paradigm_ui_web_shared_1 = require("@miracledevs/paradigm-ui-web-shared");
var ScrollToTop = /** @class */ (function (_super) {
    tslib_1.__extends(ScrollToTop, _super);
    function ScrollToTop(transitions) {
        var _this = _super.call(this) || this;
        _this.transitions = transitions;
        _this.restrict = "A";
        return _this;
    }
    ScrollToTop_1 = ScrollToTop;
    ScrollToTop.prototype.create = function (scope, instanceElement, instanceAttributes, controller, transclude) {
        var _this = this;
        var options = {};
        this.tryGetBoolean(options, instanceAttributes, "onStateChange");
        this.tryGetBoolean(options, instanceAttributes, "onClick");
        scope.$watch(function () { return instanceAttributes["onStateChange"]; }, function (newValue) {
            if (newValue === "true") {
                if (paradigm_ui_web_shared_1.ObjectExtensions.isNull(instanceElement[0]["stateChangeEvent"])) {
                    instanceElement[0]["stateChangeEvent"] = _this.transitions.onSuccess({}, function () {
                        $("body").scrollTop(0);
                    });
                }
            }
            else {
                if (!paradigm_ui_web_shared_1.ObjectExtensions.isNull(instanceElement[0]["stateChangeEvent"])) {
                    instanceElement[0]["stateChangeEvent"]();
                    instanceElement[0]["stateChangeEvent"] = null;
                }
            }
        });
        if (options.onClick) {
            instanceElement.on("click", function () {
                $("body").scrollTop(0);
            });
        }
    };
    ScrollToTop.factory = function (transitions) {
        return new ScrollToTop_1(transitions);
    };
    ScrollToTop = ScrollToTop_1 = tslib_1.__decorate([
        directive_1.Directive({
            name: "scrollToTop",
            factory: ScrollToTop_1.factory,
            dependencies: [angular_service_1.AngularServices.transitions]
        })
    ], ScrollToTop);
    return ScrollToTop;
    var ScrollToTop_1;
}(base_directive_1.DirectiveBase));
exports.ScrollToTop = ScrollToTop;
