"use strict";
/*!
 * Paradigm UI Web
 * Copyright (c) 2017 Miracle Devs, Inc
 * Licensed under MIT (https://gitlab.com/miracledevs-paradigm/ui-web-angularjs/blob/master/LICENSE)
 */
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var base_directive_1 = require("./base.directive");
var directive_1 = require("../decorators/directive");
var SelectToggleClass = /** @class */ (function (_super) {
    tslib_1.__extends(SelectToggleClass, _super);
    function SelectToggleClass() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.restrict = "A";
        return _this;
    }
    SelectToggleClass_1 = SelectToggleClass;
    SelectToggleClass.prototype.create = function (scope, instanceElement, instanceAttributes, controller, transclude) {
        var className = instanceAttributes["selectToggleClass"];
        function documentClick() {
            instanceElement.removeClass(className);
        }
        $("html").on("click.selectToggleClass", documentClick);
        instanceElement.on("click", function (e) {
            e.stopPropagation();
            instanceElement.toggleClass(className);
        });
    };
    SelectToggleClass.prototype.dispose = function (scope, instanceElement, instanceAttributes, controller, transclude) {
        $("html").unbind("click.selectToggleClass");
        _super.prototype.dispose.call(this, scope, instanceElement, instanceAttributes, controller, transclude);
    };
    SelectToggleClass.factory = function () {
        return new SelectToggleClass_1();
    };
    SelectToggleClass = SelectToggleClass_1 = tslib_1.__decorate([
        directive_1.Directive({
            name: "selectToggleClass",
            factory: SelectToggleClass_1.factory
        })
    ], SelectToggleClass);
    return SelectToggleClass;
    var SelectToggleClass_1;
}(base_directive_1.DirectiveBase));
exports.SelectToggleClass = SelectToggleClass;
